#!/usr/local/bin/ruby
# drbauth.rb - DRbAuth module
#
# $Date: 2000/09/11 12:17:54 $
# Copyright (c) 2000 Masatoshi SEKI
#
# drbauth.rb is copyrighted free software by Masatoshi SEKI.
# You can redistribute it and/or modify it under the same term as Ruby.

require 'drb/drb'
require 'md5'

module DRbAuth
  class DRbAuthError < StandardError; end

  def digest(phrase, salt)
    MD5.new(phrase + salt).digest
  end
  module_function :digest

  class Front
    def initialize(ticket_server)
      @ticket_server = ticket_server
    end

    def checkout(ticket)
      name, rsrc = @ticket_server.check_sign(ticket)
      it = fetch(rsrc, name)
      ticket.store(it)
    end

    def fetch(rsrc_name, user_name)
      nil
    end
  end

  class Ticket 
    include DRbUndumped
    def initialize(name, phrase, rsrc)
      @name = name
      @phrase = DRbAuth::digest(name, phrase)
      @rsrc = rsrc
    end

    def sign(salt)
      begin
	[@name, DRbAuth::digest(@phrase, salt), @rsrc]
      ensure
	@name = @phrase = nil
      end
    end

    def store(obj)
      @obj = obj
    end

    def retrieve
      begin
	@obj
      ensure
	@obj = nil
      end
    end
  end
end

