#!/usr/local/bin/ruby
# pserv.rb - simple SignServer 1
#
# $Date: 2000/09/11 17:00:19 $
# Copyright (c) 2000 Masatoshi SEKI
#
# pserv.rb is copyrighted free software by Masatoshi SEKI.
# You can redistribute it and/or modify it under the same term as Ruby.

require 'drb/drb'
require 'drbauth'

class SignServer
  def initialize(dict)
    @dict = dict
  end

  def check_sign(ticket)
    salt = Time.now.to_s
    name, g_sign, opt = ticket.sign(salt)
    if @dict[name].nil? or DRbAuth::digest(@dict[name], salt) != g_sign
      raise DRbAuth::DRbAuthError 
    end
    [name, opt]
  end
end

if __FILE__ == $0
  users = { 'mas'=>'mas00', 'seki'=>'seki00' }

  users.keys.each do |k|
    users[k] = DRbAuth.digest(k, users[k])
  end

  ts = SignServer.new(users)

  DRb.start_service('druby://:8472', ts)
  puts DRb.uri

  if $DEBUG
    gets
    exit
  else
    DRb.thread.join
  end
end
