#!/usr/local/bin/ruby
# signc.rb - SignServer Client
#
# $Date: 2000/09/11 17:00:19 $
# Copyright (c) 2000 Masatoshi SEKI
#
# drbauth.rb is copyrighted free software by Masatoshi SEKI.
# You can redistribute it and/or modify it under the same term as Ruby.

require 'drb'
require 'drbauth'

def session(there, rsrc, user, pass)
  ticket = DRbAuth::Ticket.new(user, pass, rsrc)
  there.checkout(ticket)
  ticket.retrieve
end

begin
  there = DRbObject.new(nil, ARGV.shift)
  op = ARGV.shift || raise 
  case op
  when 'add'
    adm_pass = ARGV.shift || raise 
    user = ARGV.shift || raise
    pass = ARGV.shift || raise
  when 'set'
    user = ARGV.shift || raise
    pass = ARGV.shift || raise
    new_pass = ARGV.shift || raise
  else
    raise
  end
rescue
  puts "usage: ruby #{$0} <uri> (add <admpass> <user> <pass>)|(set <user> <old> <new>)"
  exit
end

DRb.start_service

case op
when 'add'
  it = session(there, nil, 'adm', adm_pass)
  it.add_user(user, pass)
when 'set'
  it = session(there, nil, user, pass)
  it.set_pass(user, new_pass)
end

