#!/usr/local/bin/ruby
# srv.rb - DRbAuth sample server
#
# $Date: 2000/09/11 12:17:54 $
# Copyright (c) 2000 Masatoshi SEKI
#
# srv.rb is copyrighted free software by Masatoshi SEKI.
# You can redistribute it and/or modify it under the same term as Ruby.


require 'drb/drb'
require 'drbauth'

class MyFront < DRbAuth::Front
  def initialize(ts)
    super(ts)
    @dict = Hash.new([nil, nil])
  end

  def regist(obj, rsrc, users=nil)
    @dict[rsrc] = [obj, users]
  end
  
  def fetch(rsrc, name)
    obj, users = @dict[rsrc]
    if users
      raise(DRbAuth::DRbAuthError) unless users.include?(name)
    end
    @dict[rsrc][0]
  end
end

class Foo
  include DRbUndumped
  def initialize(msg)
    @msg = msg.dup
  end
  attr_reader :msg
end

begin
  ticket_server = DRbObject.new(nil, ARGV.shift)
rescue
  puts "usage: ruby #{$0} <ticket_uri>"
end
front = MyFront.new(ticket_server)
front.regist(Foo.new("Hello, "), "hello", %w(seki mas))
front.regist(Foo.new("World"), "world", %w(mas))
front.regist(Foo.new("who"), "who", nil)
DRb.start_service('druby://:7950', front)

puts DRb.uri

if $DEBUG
  gets
  exit
else
  DRb.thread.join
end




